import random
from playfield import PlayField

class BasePlayer:

    def __init__(self, my_sym, opp_sym, empty_sym):
        self.my_sym = my_sym
        self.opp_sym = opp_sym
        self.empty_sym = empty_sym

    def move(self, field):
        pf = PlayField(field, empty_sym=self.empty_sym)
        empty = pf.get_empty_positions()
        best_pos = self.find_best_move(empty)
        return best_pos.r, best_pos.c

    def find_best_move(self, empty_pos):
        raise "Not implemented"


class StupidPlayer(BasePlayer):
    def find_best_move(self, empty_pos):
        return empty_pos[0]

class RandomPlayer(BasePlayer):
    def find_best_move(self, empty_pos):
        return random.choice(empty_pos)

class GreedyPlayer(BasePlayer):
    def find_best_move(self, empty_pos):
        """
        for each empty_pos
        find all sequences
        return pos that maximizes the lenght
        :param empty_pos:
        :return:
        """